import { DisposableDelegate } from '@lumino/disposable';
import { ContextManager } from './manager';
import { JSLoad_3Dmol, LOAD_MIME_TYPE_3Dmol } from './renderer';
export class NBWidgetExtension {
    createNew(nb, context) {
        const manager = new ContextManager(context);
        nb.content.rendermime.addFactory({
            safe: false,
            mimeTypes: [LOAD_MIME_TYPE_3Dmol],
            createRenderer: (options) => new JSLoad_3Dmol(options)
        }, 0);
        return new DisposableDelegate(() => {
            if (nb.content.rendermime) {
                nb.content.rendermime.removeMimeType(LOAD_MIME_TYPE_3Dmol);
            }
            manager.dispose();
        });
        nb.content.rendermime.addFactory({
            safe: false,
            mimeTypes: [LOAD_MIME_TYPE_3Dmol],
            createRenderer: options => new JSLoad_3Dmol(options)
        }, 0);
    }
}
export const extension = {
    id: 'jupyterlab_3Dmol',
    autoStart: true,
    activate: (app) => {
        app.docRegistry.addWidgetExtension('Notebook', new NBWidgetExtension());
    }
};
